
package de.ivu.elect.presentation.ergebnis.dokumente.gesamtergebnis;

import static java.util.Arrays.asList;
import static java.util.Collections.singletonList;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.GroupedConversationScoped;

import de.ivu.elect.business.dokumente.boundary.AbstractDokumentGenerator;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.boundary.GesamtErgebnisVergleichDokumentContext;
import de.ivu.elect.business.ergebnis.boundary.GesamtErgebnisVergleichDokumentGenerator;
import de.ivu.elect.business.ergebnis.control.ErgebnisExchangeContext;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.ergebnis.entity.Stimmabgabeart;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.boundary.ErgebniseingangKonfiguration;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.dokumente.AbstractDokumentErzeugenView;
import de.ivu.elect.presentation.dokumente.ElectDokumentContextGenerator;
import de.ivu.elect.presentation.ergebnis.ErgebnisStatusInfo;
import de.ivu.elect.presentation.ergebnis.ViewHavingErgebnisStatusInfo;
import de.ivu.elect.presentation.ergebnis.WasErgebnisStatusInfo;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId("158")
@GroupedConversationScoped
@ConversationGroup(GesamtErgebnisVergleichDokumentErzeugenView.class)
@Named(GesamtErgebnisVergleichDokumentErzeugenView.COMPONENT_NAME)
@View(viewId = GesamtErgebnisVergleichDokumentErzeugenView.VIEW_ID, useCase = UseCasePermission.DOKUMENT_ERZEUGEN_GESAMT_ERGEBNIS_VERGLEICH)
public class GesamtErgebnisVergleichDokumentErzeugenView extends AbstractDokumentErzeugenView<Ergebnis, GesamtErgebnisVergleichDokumentContext> implements ViewHavingErgebnisStatusInfo {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gesamtErgebnisVergleichDokumentErzeugenView";

  public static final String VIEW_ID = "/ergebnis/gesamt-ergebnis-vergleich-dokument-erzeugen-view.xhtml";

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient ElectDokumentContextGenerator electDokumentContextGenerator;

  @Inject
  private transient GesamtErgebnisVergleichDokumentGenerator gesamtErgebnisVergleichDokumentGenerator;

  @Inject
  private transient ErgebniseingangKonfiguration ergebniseingangKonfiguration;

  public GesamtErgebnisVergleichDokumentErzeugenView() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.DOKUMENT_ERZEUGEN_GESAMT_ERGEBNIS_VERGLEICH;
  }

  @Override
  public String getViewId() {
    return VIEW_ID;
  }

  @Override
  @PreConditionCheck
  public String checkPreCondition() {
    if (isErgebnisSelected()) {
      return super.checkPreCondition();
    }

    return startViewResolver.getStartViewId();
  }

  public String getGebietName() {
    return getSelectedGebietNameFormatted();
  }

  @Override
  protected List<Ergebnis> getEntities() {
    return singletonList(getSelectedErgebnis());
  }

  @Override
  protected AbstractDokumentGenerator<Ergebnis, GesamtErgebnisVergleichDokumentContext> getDokumentGenerator() {
    return gesamtErgebnisVergleichDokumentGenerator;
  }

  @Override
  protected GesamtErgebnisVergleichDokumentContext getContext() {
    return createContext(new ErgebnisExchangeContext(getSelectedWahl(), asList(getSelectedGebiet()), null), Stimmabgabeart.GESAMT);
  }

  public GesamtErgebnisVergleichDokumentContext createContext(ErgebnisExchangeContext ergebnisExchangeContext, Stimmabgabeart stimmabgabeart) {
    return new GesamtErgebnisVergleichDokumentContext(electDokumentContextGenerator.createElectDokumentContext(), ergebnisExchangeContext, stimmabgabeart);
  }

  @Override
  public void addDokumentParameterProperties(FormBuilder formBuilder) {
    super.addDokumentParameterProperties(formBuilder);
  }

  @Override
  public ErgebnisStatusInfo getErgebnisStatusInfo() {
    return new WasErgebnisStatusInfo(getMessages(), getSelectedWahl(), ergebniseingangKonfiguration, getSelectedErgebnis());
  }

  private boolean isErgebnisSelected() {
    return ergebnisSessionSelect.isSelected();
  }

  private Ergebnis getSelectedErgebnis() {
    return ergebnisSessionSelect.getEntity();
  }
}
